#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cmshgroup.h"

//-----------------------------------------------------------------------------------------
CMshGroup::CMshGroup()
{
   mName = NULL;
   mMatIdx = -1;
   mTexIdx = -1;
   mTexWrap[0] = '\0';
   mNoNormal = false;
   mFlag = 0;
   mNumVerts = 0;
   mVerts = NULL;
   mNumTris = 0;
   mTris = NULL;
}
//-----------------------------------------------------------------------------------------
CMshGroup::~CMshGroup()
{
   ClearGeom();
   ClearName();
}
//-----------------------------------------------------------------------------------------
void CMshGroup::ClearGeom()
{
   if( mVerts != NULL )
   {
      for( int ix = 0; ix < mNumVerts; ++ix )
      {
         delete[] mVerts[ix];
      }
      delete[] mVerts;
      mVerts = NULL;
      mNumVerts = 0;
   }
   if( mTris != NULL )
   {
      for( int ix = 0; ix < mNumTris; ++ix )
      {
         delete[] mTris[ix];
      }
      delete[] mTris;
      mTris = NULL;
      mNumTris = NULL;
   }
}
//-----------------------------------------------------------------------------------------
void CMshGroup::AllocateGeom( int numverts, int numtris )
{
   ClearGeom();
   mNumVerts = numverts;
   mVerts = new float*[mNumVerts];
   for( int ix = 0; ix < mNumVerts; ++ix )
   {
      mVerts[ix] = new float[5];
      mVerts[ix][3] = 0.0f;
      mVerts[ix][4] = 0.0f;
   }
   mNumTris = numtris;
   mTris = new int*[mNumTris];
   for( int ix = 0; ix < mNumTris; ++ix )
   {
      mTris[ix] = new int[3];
   }
}
//-----------------------------------------------------------------------------------------
void CMshGroup::ClearName()
{
   if( mName != NULL )
   {
      delete[] mName;
      mName = NULL;
   }
}
//-----------------------------------------------------------------------------------------
void CMshGroup::SetName( char *name )
{
   ClearName();
   if( name == NULL )
   {
      return;
   }
   mName = new char[strlen( name ) + 1];
   strcpy( mName, name );
}
//-----------------------------------------------------------------------------------------
